Scala Compiler2.12.13 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package quasiquotes
  Definition Classes
    reflect
- Holes
- Parsers
- Placeholders
- Quasiquotes
- Rank
- Reifiers

t

scala.reflect.quasiquotes

# Placeholders 

###

#### trait Placeholders extends AnyRef

Emulates hole support (see Holes.scala) in the quasiquote parser (see Parsers.scala). A principled solution to splicing into Scala syntax would be a parser that natively supports holes. Unfortunately, that's outside of our reach in Scala 2.11, so we have to emulate. This trait stores knowledge of how to represent the holes as something understandable by the parser and how to recover holes from the results of parsing the produced representation.

Self Type
  Quasiquotes
Source
  Placeholders.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Quasiquotes
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Placeholders
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  trait HolePlaceholder extends AnyRef

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Placeholders to any2stringadd[Placeholders] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Placeholders, B)
   Implicit
     This member is added by an implicit conversion from Placeholders to ArrowAssoc[Placeholders] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... ) @native()
8.  lazy val code: String
9.  def ensuring(cond: (Placeholders) ⇒ Boolean, msg: ⇒ Any): Placeholders
   Implicit
     This member is added by an implicit conversion from Placeholders to Ensuring[Placeholders] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Placeholders) ⇒ Boolean): Placeholders
    Implicit
      This member is added by an implicit conversion from Placeholders to Ensuring[Placeholders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: ⇒ Any): Placeholders
    Implicit
      This member is added by an implicit conversion from Placeholders to Ensuring[Placeholders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Placeholders
    Implicit
      This member is added by an implicit conversion from Placeholders to Ensuring[Placeholders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
15.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
16.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Placeholders to StringFormat[Placeholders] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
17.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
19.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
20.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
21.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
22.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
23.  lazy val posMap: LinkedHashMap[Position, (Int, Int)]
24.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
25.  def toString(): String
    Definition Classes
      AnyRef → Any
26.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
27.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
28.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... ) @native()
29.  def →[B](y: B): (Placeholders, B)
    Implicit
      This member is added by an implicit conversion from Placeholders to ArrowAssoc[Placeholders] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
30.  object AnnotPlaceholder extends Quasiquotes.HolePlaceholder
31.  object CasePlaceholder
32.  object EarlyDefPlaceholder
33.  object ForEnumPlaceholder
34.  object FunctionTypePlaceholder
35.  object ModsPlaceholder extends Quasiquotes.HolePlaceholder
36.  object PackageStatPlaceholder
37.  object ParamPlaceholder extends Quasiquotes.HolePlaceholder
38.  object Placeholder extends Quasiquotes.HolePlaceholder
39.  object RefineStatPlaceholder
40.  object SymbolPlaceholder
41.  object TuplePlaceholder
42.  object TupleTypePlaceholder
43.  object holeMap

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Placeholders to any2stringadd[Placeholders]

### Inherited by implicit conversion StringFormat from Placeholders to StringFormat[Placeholders]

### Inherited by implicit conversion Ensuring from Placeholders to Ensuring[Placeholders]

### Inherited by implicit conversion ArrowAssoc from Placeholders to ArrowAssoc[Placeholders]

### Ungrouped